Description

When exiv2 is built using: make config; ./configure; sudo make install:

[ build objdump -x $(which exiv2) | grep RPATH

RPATH /usr/local/lib

When exiv2 is built using: mkdir build; cd build; cmake ../; sudo make install:
[ build objdump -x $(which exiv2) | grep RPATH

0 build

On operating systems like Fedora, the default search path for libraries doesn't include /usr/local/lib and hence, on executing the
binary compiled using cmake, once gets:

0 build exiv2

exiv2: error while loading shared libraries: libexiv2.s0.13: cannot open shared object file: No such file or directory
[ build Idd $(which exiv2)

linux-vdso.s0.1 => (0x00007fff0ffdf000)

libexiv2.s0.13 => not found

libdl.s0.2 => /lib64/libdl.s0.2 (0x0000003b51800000)

libexpat.so.1 => /lib64/libexpat.so.1 (0x0000003b56c00000)

libz.s0.1 => /lib64/libz.s0.1 (0x0000003b51c00000)

libstdc++.50.6 => /lib64/libstdc++.50.6 (0x0000003672200000)

libm.s0.6 => /lib64/libm.so0.6 (0x0000003b51000000)

libgce_s.so.1 => /lib64/libgcc_s.so.1 (0x0000003671a00000)

libc.s0.6 => /lib64/libc.s0.6 (0x0000003b50c00000)

/lib64/1d-linux-x86-64.s0.2 (0x0000003b50400000)

Associated revisions

Revision 3287 - 06 Aug 2014 01:32 - Robin Mills
#976 http:/dev.exiv2.org/issues/976 Thank You, Nehal for both finding and fixing this.

History

#1 - 02 Aug 2014 07:14 - Robin Mills

- Category set to build

- Status changed from New to Assigned
- Assignee set to Nehal J Wani

- Target version set to 0.25

Good find, Nehal. If you could submit a fix, | will test your fix on Mac/Cygwin/Ubuntu.

#2 - 02 Aug 2014 07:17 - Gilles Caulier

==> make config

This is not cmake config rule, but standard automake.

To configure Exiv2 with cmake, take a look to READM-CMAKE file for details...
Gilles Caulier

#3 - 02 Aug 2014 07:18 - Gilles Caulier

- Subject changed from Include Run-Time Search Path for CMake Builds in exiv2 binary to Include Run-Time Search Path for Automake Builds in
exiv2 binary
#4 - 02 Aug 2014 07:22 - Nehal J Wani

@Gilles
| think you misunderstood my problem description. | was saying that standard make config included RPATH in the binary. We need to do the same for
CMake builds.

The simple solution for this is to add:

SET (CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/1lib")

to the file

trunk/CMakeLists.txt

#5 - 02 Aug 2014 07:27 - Robin Mills

Thanks for speaking about this, Gilles. | believe Nehal is saying that the automake process is fine ( $ make config ; ./configure ; make etc).

However CMake on Fedora isn't linking correctly and requires some RPATH magic to be added. | think this is a Fedora/CMake issue. I've never
seen this on the Mac or Ubuntu.

So, | think Nehal's original title is correct by associating this issue to CMake and not automate. As always, | could be wrong!

#6 - 02 Aug 2014 07:32 - Gilles Caulier

- Subject changed from Include Run-Time Search Path for Automake Builds in exiv2 binary to Include Run-Time Search Path for Cmake Builds in
exiv2 binary

#7 - 02 Aug 2014 07:37 - Gilles Caulier

Right i read too fast...

But i never seen this kind of error under Linux, OSX and Windows using CMake (i always use CMake everywhere)
Gilles Caulier

#8 - 02 Aug 2014 07:38 - Gilles Caulier

Sound like the solution is given here :

http://www.cmake.org/pipermail/cmake/2010-February/035157.html

Gilles Caulier

#9 - 06 Aug 2014 01:33 - Robin Mills

- Status changed from Assigned to Resolved

Fix submitted r3285. Thank You, Nehal for finding and fixing this.

#10 - 21 Jun 2015 16:41 - Andreas Huggel

- Status changed from Resolved to Closed
